#include <Wire.h>
#include <SparkFun_AS7331.h>
#include <M5StickCPlus.h>
#include "AXP192.h"


SfeAS7331ArdI2C myUVSensor;

int uva = random(11);
int uvb = random(11);
int uvc = random(11);


void setup() {
  M5.begin();

  Serial.begin(115200);
  while(!Serial) {delay(100);};
  delay(1000);

  Serial.println("AS7331 UV A/B/C One-Shot mode.");

  Wire.begin();

  if(myUVSensor.begin() == false) {
    Serial.println("Error: myUVSensor.begin failed!");
    delay(10000);
    M5.Axp.PowerOff();
    while(1);}
  if(myUVSensor.prepareMeasurement(MEAS_MODE_CONT) == false) {
    Serial.println("Error: myUVSensor.prepareMeasurement failed.");
    while(1);}


  M5.Lcd.fillScreen(WHITE);
  M5.Lcd.setTextColor(BLACK);
  M5.Lcd.setTextSize(3);
  M5.Lcd.setRotation(0);
  M5.Lcd.setCursor(40, 10);
  M5.Lcd.println("UV");
  M5.Lcd.setCursor(10, 30);
  M5.Lcd.println("Sensor");
}

void loop() {
  // Send a start measurement command.
  if(kSTkErrOk != myUVSensor.setStartState(true))
    Serial.println("Error starting reading!");
  
  // Wait for a bit longer than the conversion time.
  delay(2+myUVSensor.getConversionTimeMillis());

  // Read UV values.
  if(kSTkErrOk != myUVSensor.readAllUV())
    Serial.println("Error reading UV.");
  
  uva = (int) myUVSensor.getUVA();
  uvb = (int) myUVSensor.getUVB();
  uvc = (int) myUVSensor.getUVC();

  Serial.print("UVA="); Serial.print(uva);
  Serial.print(", UVB="); Serial.print(uvb);
  Serial.print(", UVC="); Serial.println(uvc);

  M5.update();

  if(M5.BtnA.wasReleased()) {
    M5.Lcd.fillScreen(BLACK);
    M5.Lcd.setTextColor(WHITE);
    M5.Lcd.setCursor(30, 70);
    M5.Lcd.println("Power");
    M5.Lcd.setCursor(40, 100);
    M5.Lcd.println("Off!");
    Serial.println("Powering Off!");
    delay(1000);
    M5.Axp.PowerOff();
  }

  M5.Lcd.fillRect(40, 70, 100, 100, WHITE);
  M5.Lcd.setCursor(10, 80);
  M5.Lcd.print("A:"); M5.Lcd.println(uva);
  M5.Lcd.setCursor(10, 110);
  M5.Lcd.print("B:"); M5.Lcd.println(uvb);
  M5.Lcd.setCursor(10, 140);
  M5.Lcd.print("C:"); M5.Lcd.println(uvc);

  if(uva >= 1000 || uvb >= 1000 || uvc >= 1000) {
    M5.Lcd.fillRect(0, 170, 140, 70, RED);
  } else if(uva >= 100 || uvb >= 100 || uvc >= 100) {
    M5.Lcd.fillRect(0, 170, 140, 70, YELLOW);
  } else {
    M5.Lcd.fillRect(0, 170, 140, 70, GREEN);
  }

  delay(100);
}
